# This file was automatically generated by bifcl from /pobj/zeek-6.0.5/zeek-6.0.5/src/analyzer/protocol/ssl/functions.bif (plugin mode).

export {



## Sets if the SSL analyzer should consider the connection established (handshake
## finished successfully).
##
## c: The SSL connection.
##
## Returns: T on success, F on failure.
global set_ssl_established: function(c: connection ): bool ;


## Set the secret that should be used to derive keys for the connection.
## (For TLS 1.2 this is the pre-master secret).
##
## c: The affected connection
##
## secret: secret to set
##
## Returns: T on success, F on failure.
global set_secret: function(c: connection , secret: string ): bool ;


## Set the decryption keys that should be used to decrypt
## TLS application data in the connection.
##
## c: The affected connection
##
## keys: The key buffer as derived via TLS PRF.
##
## Returns: T on success, F on failure.
global set_keys: function(c: connection , keys: string ): bool ;


## Decodes a DER-encoded distinguished name into an ASCII string,
## using the RFC2253 representation
##
## dn: DER encoded distinguished name
##
## Returns: Ascii representation on success, empty string on failure
##
## .. zeek:see:: ssl_certificate_request
global parse_distinguished_name: function(dn: string ): string ;

} # end of export section
module GLOBAL;
